
def valiksorditud(loend):
    """
    Tagastab sorditud loendi
    Sisendi suurus n = len(loend)
    Algoritmi keerukus on O(n**2)
    """
    # Tekita tühi sorditud loend
    sorditud = []
    # Võrdsusta sortimata loend sisendloendi koopiaga
    sortimata = loend[:] # Teeb koopia
    
    # Kuni on veel sortimata elemente
    while len(sortimata) > 0:
        # Leia väikseim sorimata elementidest ja tõsta see sorditud loendisse
        # Seda täidetakse n korda
        minimaalne = min(sortimata) # lineaarse keerukusega operatsioon
        sorditud.append(minimaalne)
        sortimata.remove(minimaalne)

    # Tagasta sorditud loend
    return sorditud

def kiirsorditud(loend):
    """
    Tagastab sorditud loendi
    Sisendi suurus n = len(loend)
    Algoritmi keerukus on O(n * log n)
    """
    # kui loend on pikkusega 0, siis tagasta []}
    if len(loend)==0:
        return []
    # Vali juhtelement
    juhtelement = loend[0]
    # Jaga loend kolmeks:
    # keskmised (juhtelemendiga võrdsed)
    # vaikesed (juhtelemendist väiksemad)
    # suured (juhtelemendist suuremad)
    keskmised = []
    vaikesed = []
    suured = []
    for element in loend:
        if element == juhtelement:
            keskmised.append(element)
        elif element < juhtelement:
            vaikesed.append(element)
        else:
            suured.append(element)
    # Sordi rekursiivselt vaikesed ja suured
    # tulem on sorditud vaikesed + keskmised + sorditud suured
    sorditudvaikesed = kiirsorditud(vaikesed)
    sorditudsuured = kiirsorditud(suured)
    tulem = sorditudvaikesed + keskmised + sorditudsuured
    return tulem
    

if __name__ == "__main__":
    print(valiksorditud([3, 4, 5, 8, 2, 3]))
    print(kiirsorditud([3, 4, 5, 8, 2, 3]))
